// (c) 2022 cepstrum.co.jp
// This is not free software.
//
// adaptive difference emphasis simulation program for Scilab Ver.6

clear;

MU=0.001;
BT=0.997;

indata=loadwave('male_deemp.wav');  
DATLEN=length(indata);
indata=0.95*indata/max(abs(indata));

out=zeros(1:DATLEN);
out2=zeros(1:DATLEN);

c=0;
zx=0;
pwr=0.01;
for i=1:DATLEN
  x=indata(i);
  y=x-c*zx;
  pwr=BT*pwr+(1.0-BT)*x*x;
  c=c+2.0*MU*y*zx/pwr;
  if 0.99<abs(c)
    c=0.99*sign(c)
  end
  zx=x;
  out(i)=c;
  out2(i)=y;
end

//savewave('in.wav', indata, 8000);
out2=0.95*out2/max(abs(out2));
savewave('out.wav', out2, 8000);

clf;
plot2d(indata-2, style=15, rect=[0, -3, DATLEN, 1], axesflag=1);
plot2d(out, style=2, rect=[0, -3, DATLEN, 1], axesflag=1);
plot2d(-ones(1:DATLEN));



