// (c) 2022 cepstrum.co.jp
// This is not free software.

#define MU   0.001
#define BETA 0.997

// adaptive emphasis filter
void adp_emp(float x, float *y) {
  static float zx  =0.0;
  static float coef=0.0;
  static float pwr =10.0;

  *y=x-coef*zx;
  zx=x;

  pwr=BETA*pwr+(1.0-BETA)*x*x;
  coef=coef+2.0*MU*(*y)*zx/pwr;
  if (0.99<coef) coef=0.99;
  if (coef<-0.99) coef=0.99;
}

